/**************************************************************************/
/*                                                                        */
/* mpcx_init2                                                             */
/*                                                                        */
/* creates a polynomial with space for size coefficients of precision     */
/* prec                                                                   */
/*                                                                        */
/* Copyright (C) 2007 Andreas Enge                                        */
/*                                                                        */
/* Last changes: August 31, 2007                                          */
/*                                                                        */
/**************************************************************************/

#include "mpcx-impl.h"

void mpcx_init2 (mpcx_ptr f, const int size, const mp_prec_t prec) {
   int i;

   f->prec = prec;
   f->coeff = (mpc_t *) malloc (size * sizeof (mpc_t));
   for (i = 0; i < size; i++)
      mpc_init2 (f->coeff [i], prec);
   f->size = size;
   f->deg = -1;
}
