/**************************************************************************/
/*                                                                        */
/* mpcx_print                                                             */
/*                                                                        */
/* prints polynomials or arrays of coefficients                           */
/*                                                                        */
/* Copyright (C) 2007 Andreas Enge                                        */
/*                                                                        */
/* Last changes: September 17, 2007                                       */
/*                                                                        */
/**************************************************************************/

#include <stdio.h>
#include "mpcx-impl.h"

void mpcx_print (mpcx_srcptr h) {
   int i;

   if (h->deg == -1)
      printf ("0");
   else {
      for (i = h->deg; i >= 0; i--)
         if (mpc_cmp_si (h->coeff [i], 0) != 0) {
            printf (" + (");
            mpc_out_str (stdout, 10, 5, h->coeff [i], MPC_RNDNN);
            printf (") * X^%i", i);
         }
   }

   printf ("\n");
}
