/**************************************************************************/
/*                                                                        */
/* mpcx_realloc2                                                          */
/*                                                                        */
/* changes the number of coefficients in f to size; preserves the value   */
/* of f if it still fits, otherwise replaces it by 0.                     */
/*                                                                        */
/* Copyright (C) 2007 Andreas Enge                                        */
/*                                                                        */
/* Last changes: August 31, 2007                                          */
/*                                                                        */
/**************************************************************************/

#include "mpcx-impl.h"

void mpcx_realloc2 (mpcx_ptr f, const int size) {
   int i;

   if (size >= f->size) {
      f->coeff = realloc (f->coeff, size * sizeof (mpc_t));
      for (i = f->size; i < size; i++)
         mpc_init2 (f->coeff [i], f->prec);
      f->size = size;
   }
   else {
      for (i = size; i < f->size; i++)
         mpc_clear (f->coeff [i]);
      f->coeff = realloc (f->coeff, size * sizeof (mpc_t));
      f->size = size;
      if (f->deg >= size)
         f->deg = -1;
   }
}
