/**************************************************************************/
/*                                                                        */
/* mpfrx_init2                                                             */
/*                                                                        */
/* creates a polynomial with space for size coefficients of precision     */
/* prec                                                                   */
/*                                                                        */
/* Copyright (C) 2007 Andreas Enge                                        */
/*                                                                        */
/* Last changes: August 31, 2007                                          */
/*                                                                        */
/**************************************************************************/

#include "mpfrx-impl.h"

void mpfrx_init2 (mpfrx_ptr f, const int size, const mp_prec_t prec) {
   int i;

   f->prec = prec;
   f->coeff = (mpfr_t *) malloc (size * sizeof (mpfr_t));
   for (i = 0; i < size; i++)
      mpfr_init2 (f->coeff [i], prec);
   f->size = size;
   f->deg = -1;
}
