/**************************************************************************/
/*                                                                        */
/* mpfrx_set                                                               */
/*                                                                        */
/* copies f to h; the size of h is preserved if it is bigger than         */
/* necessary                                                              */
/*                                                                        */
/* Copyright (C) 2007 Andreas Enge                                        */
/*                                                                        */
/* Last changes: August 31, 2007                                          */
/*                                                                        */
/**************************************************************************/

#include "mpfrx-impl.h"

void mpfrx_set (mpfrx_ptr h, mpfrx_srcptr f) {
   int i;

   if (h->size < f->deg + 1)
      mpfrx_realloc2 (h, f->deg + 1);

   h->deg = f->deg;
   for (i = 0; i <= f->deg; i++)
      mpfr_set (h->coeff [i], f->coeff [i], GMP_RNDN);
}
