/**************************************************************************/
/*                                                                        */
/* utility functions for mpcx, not exported                               */
/*                                                                        */
/* Copyright (C) 2007 Andreas Enge                                        */
/*                                                                        */
/* Last changes: September 17, 2007                                       */
/*                                                                        */
/**************************************************************************/

#ifndef __MPCX_IMPL_H
#define __MPCX_IMPL_H
#include "mpcx.h"

#define MPCX_FFT_THRESHOLD 512
#define MPCX_NOFFT_THRESHOLD 1000000

#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define MIN(x,y) ((x) < (y) ? (x) : (y))

#if defined (__cplusplus)
extern "C" {
#endif
extern void mpcx_realloc2 (mpcx_ptr f, const int size);
extern void mpcx_mv (mpcx_ptr f, mpcx_srcptr g);
extern void mpcx_swap (mpcx_ptr f, mpcx_ptr g);

extern void mpcx_array_mul_fft (mpc_t *h, mpc_t *f, mpc_t *g, int m, int n);
extern void mpcx_zeta_init (mpc_t **zeta, int n, mp_prec_t prec);
extern void mpcx_zeta_clear (mpc_t *zeta, int n);
extern void mpcx_twiddle_init (mpfr_t **twiddle, int n, mp_prec_t prec);
extern void mpcx_twiddle_clear (mpfr_t *twiddle, int n);
extern void mpcx_dftrb (mpc_t *f, int n, mpfr_t *twiddle,
                        int zeta_off, int direction);

extern void mpcx_rev (mpcx_ptr h, mpcx_srcptr f, const int exp);

extern void mpcx_smul (mpcx_ptr h, mpcx_ptr f, mpcx_ptr g, const int exp);
extern void mpcx_sinv (mpcx_ptr h, mpcx_ptr f, const int exp);
#if defined (__cplusplus)
}
#endif
#endif /* ifndef __MPCX_IMPL_H */
