/**************************************************************************/
/*                                                                        */
/* utility functions for mpfrx, not exported                              */
/*                                                                        */
/* Copyright (C) 2007 Andreas Enge                                        */
/*                                                                        */
/* Last changes: September 17, 2007                                       */
/*                                                                        */
/**************************************************************************/

#ifndef __MPFRX_IMPL_H
#define __MPFRX_IMPL_H
#include "mpfrx.h"

#define MPFRX_FFT_THRESHOLD 512
#define MPFRX_NOFFT_THRESHOLD 1000000

#define MAX(x,y) ((x) > (y) ? (x) : (y))
#define MIN(x,y) ((x) < (y) ? (x) : (y))

#if defined (__cplusplus)
extern "C" {
#endif
extern void mpfrx_realloc2 (mpfrx_ptr f, const int size);
extern void mpfrx_mv (mpfrx_ptr f, mpfrx_srcptr g);
extern void mpfrx_swap (mpfrx_ptr f, mpfrx_ptr g);

extern void mpfrx_array_mul_fft (mpfr_t *h, mpfr_t *f, mpfr_t *g,
                                 int m, int n);

extern void mpfrx_rev (mpfrx_ptr h, mpfrx_srcptr f, const int exp);

extern void mpfrx_smul (mpfrx_ptr h, mpfrx_ptr f, mpfrx_ptr g, const int exp);
extern void mpfrx_sinv (mpfrx_ptr h, mpfrx_ptr f, const int exp);
#if defined (__cplusplus)
}
#endif
#endif /* ifndef __MPFRX_IMPL_H */
